<ng-select #select class="cui-ng-select"
           (keydown)="onKeyDown($event)"
           [formControl]="formControl"
           [addTag]="addTag"
           [addTagText]="config.i18n.addTag"
           [bindValue]="bindValue"
           [bindLabel]="bindLabel"
           [closeOnSelect]="!multiple || !!addTag"
           [clearSearchOnAdd]="multiple"
           [clearAllText]="config.i18n.clearAll"
           [clearable]="clearable"
           [compareWith]="compareWith"
           [typeahead]="typeahead"
           [items]="items"
           [loading]="loading"
           [loadingText]="config.i18n.loading"
           [labelForId]="id"
           [inputAttrs]="inputAttrs"
           [maxSelectedItems]="maxSelectedItems"
           [multiple]="multiple"
           [notFoundText]="config.i18n.notFound"
           [searchable]="searchable"
           [groupBy]="groupBy"
           [selectOnTab]="selectOnTab"
           [markFirst]="markFirst"
           [hideSelected]="hideSelected"
           [searchFn]="searchFn"
           [trackByFn]="trackByFn"
           [tabIndex]="tabIndex || 0"
           [virtualScroll]="virtualScroll"
           [appendTo]="selectContainerConfig?.containerSelector || 'body'"
           (change)="onChange($event)"
           (clear)="clearEvent.emit()"
           (scroll)="scrollEvent.emit($event)"
           (scrollToEnd)="scrollToEndEvent.emit()"
           (search)="search.emit($event.term)"
           (add)="tagAdded($event)"
           (remove)="tagRemoved($event)"
           (blur)="focusChanged()"
           (open)="setupDropdown()">
  <ng-template #cuiDefaultLabelTemplate let-item="item" let-label="label" let-clear="clear">{{ label }}</ng-template>
  <ng-template ng-label-tmp let-item="item" let-clear="clear" let-label="label">
    <span class="ng-value-label">
      <ng-template
        [ngTemplateOutlet]="labelTemplate || cuiDefaultLabelTemplate"
        [ngTemplateOutletContext]="{ item: item, clear: clear, label: label }">
      </ng-template>
    </span>
    <button class="ng-value-icon test" cui-icon-button icon="clear" size="xs" mode="ghost" type="button"
            [attr.aria-label]="config.i18n.clearItem + ' ' + label"
            (click)="clear(item)"></button>
  </ng-template>
  <ng-template #cuiDefaultOptionTemplate let-item$="item$">{{ item$.label }}</ng-template>
  <ng-template ng-option-tmp let-item="item" let-item$="item$" let-index="index" let-searchTerm="searchTerm">
    <cui-checkbox *ngIf="multiple" id="{{id}}-item-{{index}}" class="ng-select-multi-checkbox"
                  [ngModel]="item$.selected" (click)="onCheckBoxClick($event);" aria-hidden="true"></cui-checkbox>
    <ng-template
      [ngTemplateOutlet]="optionTemplate || cuiDefaultOptionTemplate"
      [ngTemplateOutletContext]="{ item: item, item$: item$, index: index, searchTerm: searchTerm }">
    </ng-template>
  </ng-template>
  <ng-template *ngIf="tagTemplate" ng-tag-tmp let-item="item" let-item$="item$" let-index="index" let-searchTerm="searchTerm">
    <ng-template
      [ngTemplateOutlet]="tagTemplate"
      [ngTemplateOutletContext]="{ item: item, item$: item$, index: index, searchTerm: searchTerm }">
    </ng-template>
  </ng-template>
  <ng-template ng-loadingspinner-tmp>
    <cui-spinner class="ng-select-spinner" size="s"></cui-spinner>
  </ng-template>
  <ng-container *ngIf="headerTemplate">
    <ng-template ng-header-tmp>
      <ng-template
        [ngTemplateOutlet]="headerTemplate">
      </ng-template>
    </ng-template>
  </ng-container>
</ng-select>
